/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : BitIoLdd4.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : BitIO_LDD
**     Version     : Component 01.031, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-22, 10:39, # CodeGen: 16
**     Abstract    :
**         The HAL BitIO component provides a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL BitIO API are simpler and more
**         portable to various microprocessors.
**     Settings    :
**          Component name                                 : BitIoLdd4
**          Pin for I/O                                    : TSI0_CH5/PTA4/I2C1_SDA/TPM0_CH1/NMI_b
**          Pin signal                                     : DB4_D4
**          Direction                                      : Input/Output
**          Initialization                                 : 
**            Init. direction                              : Output
**            Init. value                                  : 0
**            Auto Initialization                          : yes
**          Safe mode                                      : yes
**     Contents    :
**         Init      - LDD_TDeviceData* BitIoLdd4_Init(LDD_TUserData *UserDataPtr);
**         SetDir    - void BitIoLdd4_SetDir(LDD_TDeviceData *DeviceDataPtr, bool Dir);
**         SetInput  - void BitIoLdd4_SetInput(LDD_TDeviceData *DeviceDataPtr);
**         SetOutput - void BitIoLdd4_SetOutput(LDD_TDeviceData *DeviceDataPtr);
**         GetVal    - bool BitIoLdd4_GetVal(LDD_TDeviceData *DeviceDataPtr);
**         PutVal    - void BitIoLdd4_PutVal(LDD_TDeviceData *DeviceDataPtr, bool Val);
**         ClrVal    - void BitIoLdd4_ClrVal(LDD_TDeviceData *DeviceDataPtr);
**         SetVal    - void BitIoLdd4_SetVal(LDD_TDeviceData *DeviceDataPtr);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __BitIoLdd4_H
#define __BitIoLdd4_H

/* MODULE BitIoLdd4. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "IO_Map.h"
#include "GPIO_PDD.h"

#include "Cpu.h"



/* Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define BitIoLdd4_PRPH_BASE_ADDRESS  0x400FF000U
  
/* Device data structure pointer used when auto initialization property is enabled. This constant can be passed as a first parameter to all component's methods. */
#define BitIoLdd4_DeviceData  ((LDD_TDeviceData *)PE_LDD_GetDeviceStructure(PE_LDD_COMPONENT_BitIoLdd4_ID))

/* Methods configuration constants - generated for all enabled component's methods */
#define BitIoLdd4_Init_METHOD_ENABLED
#define BitIoLdd4_SetDir_METHOD_ENABLED
#define BitIoLdd4_SetInput_METHOD_ENABLED
#define BitIoLdd4_SetOutput_METHOD_ENABLED
#define BitIoLdd4_GetVal_METHOD_ENABLED
#define BitIoLdd4_PutVal_METHOD_ENABLED
#define BitIoLdd4_ClrVal_METHOD_ENABLED
#define BitIoLdd4_SetVal_METHOD_ENABLED

/* Definition of implementation constants */
#define BitIoLdd4_MODULE_BASE_ADDRESS FPTA_BASE_PTR /* Name of macro used as the base address */
#define BitIoLdd4_PORTCONTROL_BASE_ADDRESS PORTA_BASE_PTR /* Name of macro used as the base address */
#define BitIoLdd4_PORT_MASK 0x10U      /* Mask of the allocated pin from the port */



LDD_TDeviceData* BitIoLdd4_Init(LDD_TUserData *UserDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_Init (component BitIO_LDD)
**
**     Description :
**         Initializes the device. Allocates memory for the device data
**         structure, allocates interrupt vectors and sets interrupt
**         priority, sets pin routing, sets timing, etc. If the "Enable
**         in init. code" is set to "yes" value then the device is also
**         enabled(see the description of the Enable() method). In this
**         case the Enable() method is not necessary and needn't to be
**         generated. 
**     Parameters  :
**         NAME            - DESCRIPTION
**       * UserDataPtr     - Pointer to the user or
**                           RTOS specific data. This pointer will be
**                           passed as an event or callback parameter.
**     Returns     :
**         ---             - Pointer to the dynamically allocated
**                           private structure or NULL if there was an
**                           error.
** ===================================================================
*/

void BitIoLdd4_SetDir(LDD_TDeviceData *DeviceDataPtr, bool Dir);
/*
** ===================================================================
**     Method      :  BitIoLdd4_SetDir (component BitIO_LDD)
**
**     Description :
**         Sets a pin direction (available only if the direction =
**         _[input/output]_).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Dir             - Direction to set. Possible values:
**                           <false> - Input
**                           <true> - Output
**     Returns     : Nothing
** ===================================================================
*/

void BitIoLdd4_SetInput(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_SetInput (component BitIO_LDD)
**
**     Description :
**         Sets a pin direction to input (available only if the
**         direction = _[input/output]_).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

void BitIoLdd4_SetOutput(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_SetOutput (component BitIO_LDD)
**
**     Description :
**         Sets a pin direction to output (available only if the
**         direction = _[input/output]_).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

bool BitIoLdd4_GetVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_GetVal (component BitIO_LDD)
**
**     Description :
**         Returns the input/output value. If the direction is [input]
**         then the input value of the pin is read and returned. If the
**         direction is [output] then the last written value is read
**         and returned (see <Safe mode> property for limitations).
**         This method cannot be disabled if direction is [input].
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**     Returns     :
**         ---             - Input or output value. Possible values:
**                           <false> - logical "0" (Low level)
**                           <true> - logical "1" (High level)
** ===================================================================
*/

void BitIoLdd4_PutVal(LDD_TDeviceData *DeviceDataPtr, bool Val);
/*
** ===================================================================
**     Method      :  BitIoLdd4_PutVal (component BitIO_LDD)
**
**     Description :
**         The specified output value is set. If the direction is <b>
**         input</b>, the component saves the value to a memory or a
**         register and this value will be written to the pin after
**         switching to the output mode (using <tt>SetDir(TRUE)</tt>;
**         see <a href="BitIOProperties.html#SafeMode">Safe mode</a>
**         property for limitations). If the direction is <b>output</b>,
**         it writes the value to the pin. (Method is available only if
**         the direction = <u><tt>output</tt></u> or <u><tt>
**         input/output</tt></u>).
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Device data structure
**                           pointer returned by <Init> method.
**         Val             - Output value. Possible values:
**                           <false> - logical "0" (Low level)
**                           <true> - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/

void BitIoLdd4_ClrVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_ClrVal (component BitIO_LDD)
**
**     Description :
**         Clears (set to zero) the output value. It is equivalent to
**         the [PutVal(FALSE)]. This method is available only if the
**         direction = _[output]_ or _[input/output]_.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to device data
**                           structure returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

void BitIoLdd4_SetVal(LDD_TDeviceData *DeviceDataPtr);
/*
** ===================================================================
**     Method      :  BitIoLdd4_SetVal (component BitIO_LDD)
**
**     Description :
**         Sets (to one) the output value. It is equivalent to the
**         [PutVal(TRUE)]. This method is available only if the
**         direction = _[output]_ or _[input/output]_.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * DeviceDataPtr   - Pointer to device data
**                           structure returned by <Init> method.
**     Returns     : Nothing
** ===================================================================
*/

/* END BitIoLdd4. */

#endif
/* ifndef __BitIoLdd4_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
