/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DB51.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : BitIO
**     Version     : Component 02.086, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-22, 11:24, # CodeGen: 19
**     Abstract    :
**         This component "BitIO" implements an one-bit input/output.
**         It uses one bit/pin of a port.
**         Methods of this component are mostly implemented as a macros
**         (if supported by target language and compiler).
**     Settings    :
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       31            |  PTA5/USB_CLKIN/TPM0_CH2
**             ----------------------------------------------------
**
**         Port name                   : PTA
**
**         Bit number (in port)        : 5
**         Bit mask of the port        : 0x0020
**
**         Initial direction           : Output (direction can be changed)
**         Safe mode                   : yes
**         Initial output value        : 0
**         Initial pull option         : off
**
**         Port data register          : GPIOA_PDOR [0x400FF000]
**         Port control register       : GPIOA_PDDR [0x400FF014]
**
**         Optimization for            : speed
**     Contents    :
**         SetDir    - void DB51_SetDir(bool Dir);
**         SetInput  - void DB51_SetInput(void);
**         SetOutput - void DB51_SetOutput(void);
**         GetVal    - bool DB51_GetVal(void);
**         PutVal    - void DB51_PutVal(bool Val);
**         ClrVal    - void DB51_ClrVal(void);
**         SetVal    - void DB51_SetVal(void);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __DB51_H
#define __DB51_H

/* MODULE DB51. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "BitIoLdd9.h"

#include "Cpu.h"




/*
** ===================================================================
**     Method      :  DB51_SetDir (component BitIO)
**
**     Description :
**         This method sets direction of the component.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Dir        - Direction to set (FALSE or TRUE)
**                      FALSE = Input, TRUE = Output
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_SetDir(Dir) (BitIoLdd9_SetDir(BitIoLdd9_DeviceData, (Dir)))

/*
** ===================================================================
**     Method      :  DB51_SetInput (component BitIO)
**
**     Description :
**         This method sets direction of the component to input.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_SetInput() (BitIoLdd9_SetInput(BitIoLdd9_DeviceData))

/*
** ===================================================================
**     Method      :  DB51_SetOutput (component BitIO)
**
**     Description :
**         This method sets direction of the component to output.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_SetOutput() (BitIoLdd9_SetOutput(BitIoLdd9_DeviceData))

/*
** ===================================================================
**     Method      :  DB51_GetVal (component BitIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pin and returns it
**           b) direction = Output : returns the last written value
**     Parameters  : None
**     Returns     :
**         ---             - Input value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)

** ===================================================================
*/
#define DB51_GetVal() (BitIoLdd9_GetVal(BitIoLdd9_DeviceData))

/*
** ===================================================================
**     Method      :  DB51_PutVal (component BitIO)
**
**     Description :
**         This method writes the new output value.
**           a) direction = Input  : sets the new output value;
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes the value to the
**                                   appropriate pin
**     Parameters  :
**         NAME       - DESCRIPTION
**         Val             - Output value. Possible values:
**                           FALSE - logical "0" (Low level)
**                           TRUE - logical "1" (High level)
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_PutVal(Val) (BitIoLdd9_PutVal(BitIoLdd9_DeviceData, (Val)))

/*
** ===================================================================
**     Method      :  DB51_ClrVal (component BitIO)
**
**     Description :
**         This method clears (sets to zero) the output value.
**           a) direction = Input  : sets the output value to "0";
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes "0" to the
**                                   appropriate pin
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_ClrVal() (BitIoLdd9_ClrVal(BitIoLdd9_DeviceData))

/*
** ===================================================================
**     Method      :  DB51_SetVal (component BitIO)
**
**     Description :
**         This method sets (sets to one) the output value.
**           a) direction = Input  : sets the output value to "1";
**                                   this operation will be shown on
**                                   output after the direction has
**                                   been switched to output
**                                   (SetDir(TRUE);)
**           b) direction = Output : directly writes "1" to the
**                                   appropriate pin
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#define DB51_SetVal() (BitIoLdd9_SetVal(BitIoLdd9_DeviceData))

/* END DB51. */

#endif 
/* ifndef __DB51_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
